// use kayak_ui::widgets::{Element, Text};
use bevy::prelude::*;
use kayak_ui::prelude::*;
use kayak_ui::widgets::{ElementBundle, TextWidgetBundle};

use crate::ui::prelude::{px, simple_text, stretch, val_auto, value};
use crate::{basic_widget, empty_props};

empty_props!(DebugInfoProps);
basic_widget!(DebugInfoProps => DebugInfoWidget);

pub fn render_debug_info(
	In((mut widget_context, entity)): In<(KayakWidgetContext, Entity)>,
	mut commands: Commands,
) -> bool {
	let parent_id = Some(entity);
	static VERSION: &str = env!("CARGO_PKG_VERSION");

	let element_style = KStyle {
		position_type: value(KPositionType::SelfDirected),
		right: px(20.0),
		bottom: px(20.0),
		left: stretch(1.0),
		top: stretch(1.0),
		width: val_auto(),
		height: val_auto(),
		..Default::default()
	};

	rsx! {
		<ElementBundle styles={element_style}>
			<TextWidgetBundle text={simple_text(VERSION, "mono", 32.0)} />
		</ElementBundle>
	};

	true
}
