/// Almost all of these base components are copy/pasted from Advent Realms, but will soon be published
/// in the `advent_ui` package. Take a peak!
mod a_text_box;
mod button;
mod debug_info;
mod h_divider;
mod image_button;
mod inset_icon;
mod panel;
mod panel_stat;
mod v_divider;

pub use self::a_text_box::{
	cursor_animation_system, render_text_box_widget, ATextBoxProps, ATextBoxState, ATextBoxWidget,
};
pub use self::button::{
	button_props, render_button_widget, ButtonWidget, ButtonWidgetProps, ButtonWidgetState,
};
pub use self::debug_info::{render_debug_info, DebugInfoProps, DebugInfoWidget};
pub use self::h_divider::{render_h_divider, HDividerWidget, HDividerWidgetProps};
pub use self::image_button::{
	render_image_button_widget, ImageButtonWidget, ImageButtonWidgetProps, ImageButtonWidgetState,
};
pub use self::inset_icon::{
	render_inset_icon_widget, IconContent, InsetIconProps, InsetIconWidget,
};
pub use self::panel::{render_panel_widget, PanelProps, PanelVariant, PanelWidget};
pub use self::panel_stat::{render_panel_stat_widget, PanelStatProps, PanelStatWidget};
pub use self::v_divider::{render_v_divider, VDividerWidget, VDividerWidgetProps};
