mod apack_loader;

mod micro_asset_io {
	use bevy_app::{App, Plugin};
	use bevy_asset::AddAsset;

	pub struct MicroAssetIOPlugin;
	impl Plugin for MicroAssetIOPlugin {
		fn build(&self, app: &mut App) {
			app.add_event::<super::apack_loader::APackProcessingComplete>()
				.add_asset::<super::apack_loader::APack>()
				.add_asset_loader(super::apack_loader::APackLoader)
				.add_system(super::apack_loader::process_loaded_apacks)
				.add_system(super::apack_loader::poll_apack_loading_tasks);
		}
	}
}

pub use apack_loader::{APack, APackLoader, APackProcessingComplete, ClonableAPack, ProcessAPack};
pub use micro_asset_io::MicroAssetIOPlugin;
